> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/security-testing-agent-apis/security-testing-orchestration/qwiet.md).

# Qwiet

Qwiet/ShiftLeft integration endpoints

## Get Qwiet proxy configuration

> Get Qwiet proxy configuration and feature flag status for the account

```json
{"openapi":"3.0.3","info":{"title":"Harness Security Test Orchestration API","version":"1.0.0"},"tags":[{"name":"Qwiet","description":"Qwiet/ShiftLeft integration endpoints"}],"servers":[{"url":"https://app.harness.io/gateway/sto"},{"url":"http://127.0.0.1:4000"}],"security":[{"X-Api-Key_header_X-Api-Key":[],"jwt_header_Authorization":["sto_scan_view"]}],"components":{"securitySchemes":{"X-Api-Key_header_X-Api-Key":{"type":"apiKey","name":"X-Api-Key","in":"header"},"jwt_header_Authorization":{"type":"http","scheme":"bearer"}},"schemas":{"QwietProxyConfigResponse":{"type":"object","properties":{"enabled":{"type":"boolean","description":"Whether STO proxy mode is enabled for this account"},"grpcApiHost":{"type":"string","description":"STO gRPC API host:port. Same value as grpcTelemetryHost. Set only when enabled is true."},"grpcTelemetryHost":{"type":"string","description":"STO gRPC telemetry host:port. Same value as grpcApiHost. Set only when enabled is true."}},"required":["enabled"]},"NotFound":{"type":"object","properties":{"message":{"type":"string"},"status":{"type":"integer","default":404,"format":"int64"}},"required":["message"]}}},"paths":{"/api/v2/qwiet/proxy-config":{"get":{"tags":["Qwiet"],"summary":"Get Qwiet proxy configuration","description":"Get Qwiet proxy configuration and feature flag status for the account","operationId":"Qwiet#GetProxyConfig","parameters":[{"name":"accountId","in":"query","description":"Harness Account ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Account ID","pattern":"^[a-zA-Z0-9_-]{22}$"}},{"name":"X-Api-Key","in":"header","description":"Harness personal or service access token","allowEmptyValue":true,"schema":{"type":"string","description":"Harness personal or service access token"}}],"responses":{"200":{"description":"OK response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/QwietProxyConfigResponse"}}}},"400":{"description":"BadRequest: Bad Request response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"401":{"description":"Unauthorized: Unauthorized response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"403":{"description":"Forbidden: Forbidden response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"429":{"description":"TooManyRequests: Too Many Requests response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"500":{"description":"InternalServerError: Internal Server Error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}}}}}}}
```

## Resolve app scope

> Resolve and validate app scope, returning sanitized Qwiet app name and X-Harness-App header.

```json
{"openapi":"3.0.3","info":{"title":"Harness Security Test Orchestration API","version":"1.0.0"},"tags":[{"name":"Qwiet","description":"Qwiet/ShiftLeft integration endpoints"}],"servers":[{"url":"https://app.harness.io/gateway/sto"},{"url":"http://127.0.0.1:4000"}],"security":[{"X-Api-Key_header_X-Api-Key":[],"jwt_header_Authorization":["sto_scan_view"]}],"components":{"securitySchemes":{"X-Api-Key_header_X-Api-Key":{"type":"apiKey","name":"X-Api-Key","in":"header"},"jwt_header_Authorization":{"type":"http","scheme":"bearer"}},"schemas":{"ResolveAppScopeResult":{"type":"object","properties":{"harnessApp":{"type":"string","description":"Plain decoded Harness app scope ({org}/{project}/{app})"},"qwietAppName":{"type":"string","description":"Hyphenated and sanitized app name used in Qwiet API paths ({org}-{project}-{app})"},"xHarnessApp":{"type":"string","description":"Base64url-encoded X-Harness-App header value"}},"required":["qwietAppName","harnessApp","xHarnessApp"]},"NotFound":{"type":"object","properties":{"message":{"type":"string"},"status":{"type":"integer","default":404,"format":"int64"}},"required":["message"]}}},"paths":{"/api/v2/qwiet/resolve-app-scope":{"get":{"tags":["Qwiet"],"summary":"Resolve app scope","description":"Resolve and validate app scope, returning sanitized Qwiet app name and X-Harness-App header.","operationId":"Qwiet#ResolveAppScope","parameters":[{"name":"accountId","in":"query","description":"Harness Account ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Account ID","pattern":"^[a-zA-Z0-9_-]{22}$"}},{"name":"orgId","in":"query","description":"Harness Organization ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Organization ID","pattern":"^[A-Za-z_][A-Za-z0-9_]*$","maxLength":128}},{"name":"projectId","in":"query","description":"Harness Project ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Project ID","pattern":"^[A-Za-z_][A-Za-z0-9_]*$","maxLength":128}},{"name":"appName","in":"query","description":"Target/app name","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Target/app name"}},{"name":"X-Api-Key","in":"header","description":"Harness personal or service access token","allowEmptyValue":true,"schema":{"type":"string","description":"Harness personal or service access token"}}],"responses":{"200":{"description":"OK response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResolveAppScopeResult"}}}},"400":{"description":"BadRequest: Bad Request response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"401":{"description":"Unauthorized: Unauthorized response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"403":{"description":"Forbidden: Forbidden response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"429":{"description":"TooManyRequests: Too Many Requests response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"500":{"description":"InternalServerError: Internal Server Error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}}}}}}}
```

## Poll Harness scans by Qwiet app name and polyglot scan ids

> Look up Harness scans by Qwiet applicationName and polyglotScanIds stored on scan.metadata.

```json
{"openapi":"3.0.3","info":{"title":"Harness Security Test Orchestration API","version":"1.0.0"},"tags":[{"name":"Qwiet","description":"Qwiet/ShiftLeft integration endpoints"}],"servers":[{"url":"https://app.harness.io/gateway/sto"},{"url":"http://127.0.0.1:4000"}],"security":[{"X-Api-Key_header_X-Api-Key":[],"jwt_header_Authorization":["core_account_view"]}],"components":{"securitySchemes":{"X-Api-Key_header_X-Api-Key":{"type":"apiKey","name":"X-Api-Key","in":"header"},"jwt_header_Authorization":{"type":"http","scheme":"bearer"}},"schemas":{"QwietScanPollResult":{"type":"object","properties":{"scans":{"type":"array","items":{"$ref":"#/components/schemas/QwietScanPollItem"}}},"required":["scans"]},"QwietScanPollItem":{"type":"object","properties":{"harnessScanId":{"type":"string","description":"Harness scan id when a matching scan row exists"},"link":{"type":"string","description":"Harness STO scan-history URL"},"polyglotScanId":{"type":"integer","description":"Qwiet polyglot scan id","format":"int64"},"status":{"type":"string","description":"scan.status, or not_found when no row matches"}},"required":["polyglotScanId","status","link"]},"NotFound":{"type":"object","properties":{"message":{"type":"string"},"status":{"type":"integer","default":404,"format":"int64"}},"required":["message"]}}},"paths":{"/api/v2/qwiet/scans":{"post":{"tags":["Qwiet"],"summary":"Poll Harness scans by Qwiet app name and polyglot scan ids","description":"Look up Harness scans by Qwiet applicationName and polyglotScanIds stored on scan.metadata.","operationId":"Qwiet#GetScans","parameters":[{"name":"accountId","in":"query","description":"Harness Account ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Account ID","pattern":"^[a-zA-Z0-9_-]{22}$"}},{"name":"X-Api-Key","in":"header","description":"Harness personal or service access token","allowEmptyValue":true,"schema":{"type":"string","description":"Harness personal or service access token"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"type":"object","properties":{"applicationName":{"type":"string","description":"Qwiet app name stored as scan.metadata.AppName","minLength":1,"maxLength":256},"polyglotScanIds":{"type":"array","items":{"type":"integer","format":"int64"},"minItems":1,"maxItems":100}}}}}},"responses":{"200":{"description":"OK response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/QwietScanPollResult"}}}},"400":{"description":"BadRequest: Bad Request response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"401":{"description":"Unauthorized: Unauthorized response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"403":{"description":"Forbidden: Forbidden response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"429":{"description":"TooManyRequests: Too Many Requests response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"500":{"description":"InternalServerError: Internal Server Error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}}}}}}}
```

## Get Qwiet token

> Get Qwiet token and organization ID for an account

```json
{"openapi":"3.0.3","info":{"title":"Harness Security Test Orchestration API","version":"1.0.0"},"tags":[{"name":"Qwiet","description":"Qwiet/ShiftLeft integration endpoints"}],"servers":[{"url":"https://app.harness.io/gateway/sto"},{"url":"http://127.0.0.1:4000"}],"security":[{"X-Api-Key_header_X-Api-Key":[],"jwt_header_Authorization":["sto_scan_view"]}],"components":{"securitySchemes":{"X-Api-Key_header_X-Api-Key":{"type":"apiKey","name":"X-Api-Key","in":"header"},"jwt_header_Authorization":{"type":"http","scheme":"bearer"}},"schemas":{"QwietTokenResponse":{"type":"object","properties":{"authorized":{"type":"boolean","description":"Authorization status (sast/sca license types)"},"licenseType":{"type":"string","description":"Type of license validated","enum":["qwiet","sast","sca"]},"organizationId":{"type":"string","description":"Qwiet organization ID (qwiet license type only)"},"token":{"type":"string","description":"Qwiet access token (qwiet license type only)"}}},"NotFound":{"type":"object","properties":{"message":{"type":"string"},"status":{"type":"integer","default":404,"format":"int64"}},"required":["message"]}}},"paths":{"/api/v2/qwiet/token":{"get":{"tags":["Qwiet"],"summary":"Get Qwiet token","description":"Get Qwiet token and organization ID for an account","operationId":"Qwiet#GetToken","parameters":[{"name":"accountId","in":"query","description":"Harness Account ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Account ID","pattern":"^[a-zA-Z0-9_-]{22}$"}},{"name":"licenseType","in":"query","description":"Type of license to validate","allowEmptyValue":true,"schema":{"type":"string","description":"Type of license to validate","default":"qwiet","enum":["qwiet","sast","sca"]}},{"name":"X-Api-Key","in":"header","description":"Harness personal or service access token","allowEmptyValue":true,"schema":{"type":"string","description":"Harness personal or service access token"}}],"responses":{"200":{"description":"OK response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/QwietTokenResponse"}}}},"400":{"description":"BadRequest: Bad Request response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"401":{"description":"Unauthorized: Unauthorized response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"403":{"description":"Forbidden: Forbidden response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"429":{"description":"TooManyRequests: Too Many Requests response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"500":{"description":"InternalServerError: Internal Server Error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}}}}}}}
```

## Get Qwiet user token

> Get Qwiet user access token for the authenticated user

```json
{"openapi":"3.0.3","info":{"title":"Harness Security Test Orchestration API","version":"1.0.0"},"tags":[{"name":"Qwiet","description":"Qwiet/ShiftLeft integration endpoints"}],"servers":[{"url":"https://app.harness.io/gateway/sto"},{"url":"http://127.0.0.1:4000"}],"security":[{"X-Api-Key_header_X-Api-Key":[],"jwt_header_Authorization":["sto_scan_view"]}],"components":{"securitySchemes":{"X-Api-Key_header_X-Api-Key":{"type":"apiKey","name":"X-Api-Key","in":"header"},"jwt_header_Authorization":{"type":"http","scheme":"bearer"}},"schemas":{"QwietUserTokenResponse":{"type":"object","properties":{"email":{"type":"string","description":"User email address. Set only when useStoProxy is false."},"grpcApiHost":{"type":"string","description":"STO gRPC host:port (API and telemetry). Set only when useStoProxy is true. One mesh."},"grpcTelemetryHost":{"type":"string","description":"Deprecated. Omitted; sl copies grpcApiHost when empty."},"organizationId":{"type":"string","description":"Qwiet organization ID. Set only when useStoProxy is false."},"token":{"type":"string","description":"Qwiet user access token. Set only when useStoProxy is false."},"useStoProxy":{"type":"boolean","description":"True when this account must call the STO proxy. False when sl calls Qwiet directly."}},"required":["useStoProxy"]},"NotFound":{"type":"object","properties":{"message":{"type":"string"},"status":{"type":"integer","default":404,"format":"int64"}},"required":["message"]}}},"paths":{"/api/v2/qwiet/user-token":{"get":{"tags":["Qwiet"],"summary":"Get Qwiet user token","description":"Get Qwiet user access token for the authenticated user","operationId":"Qwiet#GetUserToken","parameters":[{"name":"accountId","in":"query","description":"Harness Account ID","allowEmptyValue":true,"required":true,"schema":{"type":"string","description":"Harness Account ID","pattern":"^[a-zA-Z0-9_-]{22}$"}},{"name":"X-Api-Key","in":"header","description":"Harness personal or service access token","allowEmptyValue":true,"schema":{"type":"string","description":"Harness personal or service access token"}}],"responses":{"200":{"description":"OK response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/QwietUserTokenResponse"}}}},"400":{"description":"BadRequest: Bad Request response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"401":{"description":"Unauthorized: Unauthorized response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"403":{"description":"Forbidden: Forbidden response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"429":{"description":"TooManyRequests: Too Many Requests response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}},"500":{"description":"InternalServerError: Internal Server Error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFound"}}}}}}}}}
```
